// sysvar.h
// Revision 13-dec-2003

#ifndef SYSVAR_H_
#define SYSVAR_H_

namespace sysvar {

void init ();
size_t address ();

void set_cpc ();
void set_spectrum ();
void set_gwbasic ();

void set (size_t var, char value);
void set16 (size_t var, short value);
void set32 (size_t var, long value);

BlChar get (size_t var);
unsigned short get16 (size_t var);
unsigned long get32 (size_t var);

const size_t
	GraphicsWidth= 0,
	GraphicsHeight= 2,
	NumArgs= 4,
	VersionMajor= 6,
	VersionMinor= 8,
	VersionRelease= 10,
	AutoInit= 12,
	AutoInc= 16,
	CharGen= 20,
	ShellResult= 24,
	TypeOfVal= 25,	// 0: simple, 1: expression evluation,
			// else unimplemented.
	TypeOfNextCheck= 26,	// 0: normal, else ZX-type
	TypeOfDimCheck= 27,	// 0: cannot dim already dimensioned
				// 1: Silently redim
	MaxHistory= 28,	// Max size of history buffer.
	Flags1= 30,	// Bit 0: LOCATE style. 0 Microsoft, 1 Amstrad CPC.
			// Bit 1: TAB style: 0 normal, 1 Spectrum.
			// Bit 2: THEN omitted: 0 is not accepted, 1 accepted.
			// Bit 3: space before number in PRINT, 0 No, 1 Yes.
			// Bit 4: initial space in STR$, 0 No, 1 Yes.
			// Bit 5: convert LF to CR in GET and INKEY$
	PrinterLine=  31, 	// Type of printer line feed.
				// 0 LF only.
				// 1 CR + LF
				// 2 CR only.
	MaxFnLevel= 32, // Max level of FN calls.
	DebugLevel= 36, // Level for IF_DEBUG
	Zone= 38,	// Size of zone for the , separator of PRINT.
	GraphRotate= 40,	// Type of graphics rotation:
				// 0 no rotation.
				// 1 90 degrees.
				// Other: undefined
	// Rsereved: 41
	EndSysVar= 42;

// Flags1 masks.
const BlChar
	LocateStyle= 1,
	TabStyle= 2,
	ThenOmitted= 4,
	SpaceBefore= 8,
	SpaceStr_s= 16,
	ConvertLFCR= 32;

} // namespace sysvar

#endif

// Fin de sysvar.h
